
------------------
-- // Fog \\ --
------------------
local Fog = {}
Fog.__index = Fog


------------------------
-- // Declarations \\ --
------------------------

--Shortcuts
  lkid = love.keyboard.isDown



function Fog.new(o)
  local self = o or {}
  self.name         = "Fog"
  
  self.sprite       = self.sprite or love.graphics.newImage("gfx/level1_fog.png")
  

  self.minScale     = self.minScale or 2
  self.maxScale     = self.maxScale or 4
  self.x            = self.x or 0
  self.y            = self.y or 0
  
  self.minSpeed     = self.minSpeed or 60
  self.maxSpeed     = self.maxSpeed or 80
  
  self.moving       = self.moving or true
  
  self.draws        = {}
  
  self.fogRate      = self.fogRate or 1.8
    
  self.fogTimer     = 0  
  self.removed      = false
  setmetatable(self, Fog)
  return self
end


function Fog:destroy()
  self.removed = true
end

function Fog:update(dt)
  self.fogTimer = self.fogTimer + dt
  
  for i,v in ipairs(self.draws) do
    --Movement 
      v.x = v.x - v.speed * dt   
    
    --Remove when out of screen
      if v.x < 0 - self.sprite:getWidth() * v.scale then
        table.remove(self.draws, i)
      end
  end
  
  --Spawning
    if self.fogTimer > self.fogRate then
      table.insert(self.draws, {x = WIDTH, y = math.random(1, 300), speed = math.random(self.minSpeed, self.maxSpeed), scale = math.random(self.minScale, self.maxScale)})
      
      self.fogTimer = 0
    end
end


function Fog:draw()
  for i,v in ipairs(self.draws) do
    love.graphics.setColor(255,255,255,50)
    love.graphics.draw(self.sprite, v.x, v.y, 0, v.scale, v.scale)
  end
end

return Fog
