
------------------
-- // Stone \\ ----
------------------
local Stone = {}
Stone.__index = Stone

------------------------
-- // Declarations \\ --
------------------------
local _showStoneHitbox = false


function Stone.new(o)
  local self = o or {}
  self.name         = "stone"
  self.mode         = self.mode or ""
  if self.mode == "rolling" then
    self.image        = love.graphics.newImage("gfx/stone.png")
  else
    self.image        = love.graphics.newImage("gfx/ghost_bullet.png")
  end
  self.scale        = self.scale or 3
  self.w            = self.image:getWidth() * self.scale
  self.h            = self.image:getHeight() * self.scale
  self.x            = self.x or 0
  self.y            = self.y or 0
  self.r            = self.r or 0
  self.xVel         = self.xVel or -300
  self.yVel         = self.yVel or -50
  self.rVel         = self.rVel or math.random(2, 8)
  self.gravity      = self.gravity or 600
  self.ground       = self.ground or HEIGHT - 70
  self.removed      = false
  setmetatable(self, Stone)
  return self
end

function Stone:getHitbox()
  return {x = self.x - self.w / 2, y = self.y - self.h / 2, w = self.w, h = self.h}
end

function Stone:destroy()
  self.removed = true
end

function Stone:update(dt)
  self.x = self.x + self.xVel * dt
  self.r = self.r - self.rVel * dt
  
--Falling
  self.yVel = self.yVel + (self.gravity * dt)
  self.y = self.y + self.yVel * dt
  
  if self.y >= self.ground then
    if self.mode == "rolling" then
      self.yVel = 0
      self.y = self.ground
    else
      self:destroy()
    end
  end
  
  if self.x < 0 - self.w then self:destroy() end
  
end


function Stone:draw()
  love.graphics.setColor(255,255,255,255)
  love.graphics.draw(self.image, self.x, self.y, self.r, self.scale, self.scale, self.w/2 / self.scale, self.h/2 / self.scale)
    
  if _showStoneHitbox == true then
    local box = self:getHitbox()
    love.graphics.setColor(0, 0, 255, 100)
    love.graphics.rectangle("fill", box.x, box.y, box.w, box.h)
  end
end

return Stone
