
-----------------------------------
-- // Bacon Game Jam 07 Entry \\ --
-----------------------------------

--Shortcuts
  gfx = love.graphics
  lkid = love.keyboard.isDown
  
  la = love.audio
  las = love.audio.newSource

------------------------
-- // Dependencies \\ --
------------------------
  
--Libraries
  SceneManager  = require 'source.SceneManager'
  ObjectHandler = require 'source.ObjectHandler'
  Util          = require 'source.Util'
  
  Sound         = require 'source.sound'
  
  require 'libraries.AnAL'

--Entities
  Player        = require 'entities.Player'
  Parallaxing   = require 'source.Parallaxing'
  Fog           = require 'entities.Fog'
  Items         = require 'entities.Items'
  MagicMissile  = require 'entities.MagicMissile'
  Souls         = require 'entities.Souls'
  Stone         = require 'entities.Stone'
  
  Gnome         = require 'enemies.Gnome'
  Ghost         = require 'enemies.Ghost'

--Gamestates
  Game          = require 'scenes.Game'
  MainMenu      = require 'scenes.MainMenu'
  Credits       = require 'scenes.Credits'
  HowTo         = require 'scenes.HowTo'
  
--Overlays
  GameOver      = require 'scenes.GameOver'
  Pause         = require 'scenes.Pause'
  
--Sonstiged
  HUD           = require 'source.HUD'
  
--Global Vars
  WIDTH, HEIGHT = love.window.getMode()
  MUSIC         = true
  
--Fonts
  FONT = {
      tiny = love.graphics.newFont("font.ttf", 14),
      small = love.graphics.newFont("font.ttf", 19),
      medium = love.graphics.newFont("font.ttf", 48),
      large = love.graphics.newFont("font.ttf", 96),
    }


function love.load()
  --PIXEL-LOOK!
    love.graphics.setDefaultFilter("nearest", "nearest", 0)
    
  -- Loop music
    SOUNDS.music:setLooping(true)
    SOUNDS.music:setVolume(.6)
      
  --Random
    math.randomseed(os.time())
  
  SceneManager.newScene(Game, "Game")
  SceneManager.newScene(Pause, "Pause")
  SceneManager.newScene(GameOver, "GameOver")
  SceneManager.newScene(MainMenu, "MainMenu")
  SceneManager.newScene(Credits, "Credits")
  SceneManager.newScene(HowTo, "HowTo")
  
  SceneManager.setScene("Game") 
  SceneManager.setOverlay("MainMenu")
end


function love.update(dt)
  SceneManager.update(dt)
  --require("source.lurker").update(dt)
  if MUSIC then SOUNDS.music:play()
    else SOUNDS.music:stop() end
end


function love.draw()
  SceneManager.draw()
end


function love.keypressed(key, unicode)
  SceneManager.keypressed(key, unicode)
  
  if key == "+" then la.setVolume(la.getVolume() + 5) end
  if key == "-" then la.setVolume(la.getVolume() - 5) end
  if key == "m" then MUSIC = not MUSIC end
end


function love.focus(f)
  SceneManager.focus(f)
end
