
--------------------
-- // GameOver \\ --
--------------------
local GameOver = {}

------------------------
-- // Declarations \\ --
------------------------ 
local _debugging = true
local _image = {}
local buttons = {}

local function newButton(text, x, y, action)
  table.insert(buttons, {text = text, x = x, y = y, action = action, selected = false} )
end


local function updateButtons(dt)
  for k,v in ipairs(buttons) do
  end
end


local function drawButtons()
  love.graphics.setFont(FONT.medium)
  for k,v in ipairs(buttons) do
    if v.selected then
      love.graphics.setColor(255, 255, 255, 255)
      love.graphics.printf(v.text, v.x - 300, v.y, 600, "center")
    else
      love.graphics.setColor(255, 255, 255, 100)
      love.graphics.printf(v.text, v.x - 300, v.y, 600, "center")
    end
  end  
end

local function getCurrentButton()
  local buttonIndex
  for i,v in ipairs(buttons) do
      if v.selected then buttonIndex = i end
  end
  return buttonIndex
end

function GameOver:init()
end


function GameOver:enter()
  buttons = {}
  self.alpha = 255
  newButton("Again", WIDTH / 2, 340, function() SceneManager.setScene("Game") end)
  newButton("Mainmenu", WIDTH / 2, 390, function() SceneManager.setScene("Game"); SceneManager.setOverlay("MainMenu") end)
  buttons[1].selected = true
  MUSIC = false
end


function GameOver:leave()
  MUSIC = true
end


function GameOver:update(dt)
  updateButtons(dt)
  if self.alpha > 150 then
    self.alpha = self.alpha - 150 * dt
  end
end


function GameOver:draw()
  gfx.setColor(0,0,0,self.alpha)
  gfx.rectangle("fill", 0, 0, WIDTH, HEIGHT)
  
  if self.alpha <= 150 then 
  --Stats
    gfx.setColor(255,255,255,255)
    gfx.setFont(FONT.small)
  
    gfx.printf("Killed gnomes: "..KILLEDGNOMES, WIDTH / 2 - 400, 140, 800, "center")
    gfx.printf("Killed ghosts: "..KILLEDGHOSTS, WIDTH / 2 - 400, 180, 800, "center")
    gfx.printf("Collected items : "..COLLECTEDITEMS, WIDTH / 2 - 400, 220, 800, "center")
    gfx.printf("Collected souls : "..COLLECTEDSOULS, WIDTH / 2 - 400, 260, 800, "center")
    

    if SECONDSPLAYED < 10 then
      gfx.printf("Time survived: "..MINUTESPLAYED..":0"..math.floor(SECONDSPLAYED), WIDTH / 2 - 400, 300, 800, "center")
    else
      gfx.printf("Time survived: "..MINUTESPLAYED..":"..math.floor(SECONDSPLAYED), WIDTH / 2 - 400, 300, 800, "center")
    end
    drawButtons()
  end
  
end


function GameOver:keypressed(key, unicode)
  
  if key == "up" and getCurrentButton() > 1 then
    local previousButton = getCurrentButton() - 1
    buttons[getCurrentButton()].selected = false
    buttons[previousButton].selected = true
    playSound("buttonchange")
  elseif key == "down" and getCurrentButton() < #buttons then
    local nextButton = getCurrentButton() + 1
    buttons[getCurrentButton()].selected = false
    buttons[nextButton].selected = true
    playSound("buttonchange")
  end
  
  if key == "return" then
    buttons[getCurrentButton()].action()
    SOUNDS.buttonselect:play()
  end
end

return GameOver
