
--------------------
-- // MainMenu \\ --
--------------------
local MainMenu = {paused = false}

------------------------
-- // Declarations \\ --
------------------------ 
local _debugging = true

--Shortcuts
local logo
buttons = {}

local function newButton(text, x, y, action)
  table.insert(buttons, {text = text, x = x, y = y, action = action, selected = false} )
end


local function updateButtons(dt)
  for k,v in ipairs(buttons) do
  end
end


local function drawButtons()
  love.graphics.setFont(FONT.medium)
  for k,v in ipairs(buttons) do
    if v.selected then
      love.graphics.setColor(255, 255, 255, 255)
      love.graphics.printf(v.text, v.x - 300, v.y, 600, "center")
    else
      love.graphics.setColor(255, 255, 255, 100)
      love.graphics.printf(v.text, v.x - 300, v.y, 600, "center")
    end
  end  
end


local function getCurrentButton()
  local buttonIndex
  for i,v in ipairs(buttons) do
      if v.selected then buttonIndex = i end
  end
  return buttonIndex
end

  
function MainMenu:init()
  logo = love.graphics.newImage("gfx/main_logo.png")
end


function MainMenu:enter()
  self.isActive = true
  Game:enter()
  newButton("Play Game", WIDTH / 2, 250, function() SceneManager.setScene("Game"); self.isActive = false end)
  newButton("How to Play", WIDTH / 2, 300, function() SceneManager.setScene("Game"); SceneManager.setOverlay("HowTo") end)
  newButton("Credits", WIDTH / 2, 350, function() SceneManager.setScene("Game"); SceneManager.setOverlay("Credits") end)
  newButton("Exit", WIDTH / 2, 400, function() love.event.quit() end)
  buttons[1].selected = true
end


function MainMenu:leave()
  buttons = {}
end


function MainMenu:update(dt)
  updateButtons(dt)
end


function MainMenu:draw()
  love.graphics.setColor(0, 0, 0, 150)
  love.graphics.rectangle("fill", 0, 0, WIDTH, HEIGHT)
  --love.graphics.setColor(0, 0, 0, 200)
  --love.graphics.rectangle("fill", 300, 0, WIDTH - 600, HEIGHT)
  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.setFont(FONT.tiny)
  gfx.print("Bacon Game Jam 07 Entry", 15, HEIGHT - 20)
  gfx.print("Post-Compo-Edit 1", WIDTH - 120, HEIGHT - 20)
  love.graphics.draw(logo, WIDTH / 2 - (logo:getWidth() * 4) / 2, 40, 0, 4, 4)
  drawButtons()

end


function MainMenu:keypressed(key, unicode)  
  
  if key == "up" and getCurrentButton() > 1 then
    local previousButton = getCurrentButton() - 1
    buttons[getCurrentButton()].selected = false
    buttons[previousButton].selected = true
    
    playSound("buttonchange")
  elseif key == "down" and getCurrentButton() < #buttons then
    local nextButton = getCurrentButton() + 1
    buttons[getCurrentButton()].selected = false
    buttons[nextButton].selected = true
    
    playSound("buttonchange")
  end

  if key == "escape" then
    love.event.quit()
  end
  
  if key == "return" then
    buttons[getCurrentButton()].action()
    SOUNDS.buttonselect:play()
  end
end

function MainMenu:focus(f)
  
end

return MainMenu
