
------------------
-- // Parallaxing \\ --
------------------
local Parallaxing = {}
Parallaxing.__index = Parallaxing


------------------------
-- // Declarations \\ --
------------------------

--Shortcuts
local lkid = love.keyboard.isDown



function Parallaxing.new(o)
  local self = o or {}
  self.name         = "Parallaxing"
  
  self.sprites      = self.sprites
  
  self.scale        = 4
  
  self.w            = self.sprites[1]:getWidth() * self.scale
  self.h            = self.sprites[1]:getHeight() * self.scale
  
  self.x            = self.x or 0
  self.y            = self.y or 0
  
  self.xSpeed       = self.xSpeed or 100
  
  self.moving       = self.moving or true
  
  self.draws        = {}
  table.insert(self.draws, {x = self.x, y = self.y, r = 0, spawned = false, sprite = math.random(1, #self.sprites)})
  
  self.removed      = false
  setmetatable(self, Parallaxing)
  return self
end


function Parallaxing:destroy()
  self.removed = true
end

function Parallaxing:update(dt)
  for i,v in ipairs(self.draws) do
    if self.moving == true then  
      v.x = v.x + self.xSpeed * dt
    end
    
    if v.x < 0 and v.spawned == false then        
      table.insert(self.draws, {x = self.x + self.w, y = self.y, r = 0, spawned = false, sprite = math.random(1, #self.sprites)})
      v.spawned = true
    end
    
    if v.x < 0 - self.w then
      table.remove(self.draws, i)
    end
  end
end


function Parallaxing:draw()
  
 -- if self.sprite == nil then
    --love.graphics.setColor(111, 111, 111, 255)
    --love.graphics.rectangle("fill", self.x, self.y, WIDTH, HEIGHT)
 -- else
    for i,v in ipairs(self.draws) do
      love.graphics.setColor(255,255,255,255)
      love.graphics.draw(self.sprites[v.sprite], v.x, v.y, v.r, self.scale, self.scale)
    end
  --end
end

return Parallaxing
